<?xml version="1.0" encoding="utf-8"?>
<package xmlns="http://schemas.microsoft.com/packaging/2012/06/nuspec.xsd">
  <metadata>
    <id>Microsoft.PowerApps.CLI</id>
    <version>1.38.3</version>
    <title>Microsoft PowerPlatform CLI</title>
    <authors>Microsoft</authors>
    <owners>crmsdk,Microsoft</owners>
    <requireLicenseAcceptance>true</requireLicenseAcceptance>
    <license type="file">LICENSE.txt</license>
    <licenseUrl>https://aka.ms/deprecateLicenseUrl</licenseUrl>
    <icon>images\PowerApps.128x128.png</icon>
    <readme>docs\README.md</readme>
    <projectUrl>https://learn.microsoft.com/en-us/power-platform/developer/cli/introduction</projectUrl>
    <description>Microsoft PowerPlatform CLI is a simple, single-stop, developer command-line interface (CLI) for developing customizations and extensions for Microsoft PowerPlatform. See project site how to install.</description>
    <summary>This package contains the Microsoft PowerPlatform CLI.</summary>
    <releaseNotes>Please make sure to update your Microsoft Power Platform CLI to the latest version and take advantage of all the latest capabilities by following https://aka.ms/PowerPlatformCLI.
If you are a new user please install the Power Platform CLI directly from here: https://aka.ms/PowerPlatformCLI

1.38.3:
  Admin
  - New list-groups command to list all environment groups in the tenant
  - New add-group command to add an environment to an environment group

  Misc
  - Updated Microsoft Graph to 5.63.0

1.36:
  power-fx:
  - JSON not available in Power Fx https://github.com/microsoft/Power-Fx/discussions/2734 reported by https://github.com/rajyraman

  data:
  - Fixed an issue where the updateCompare flag was ignored if the target table exceeded the default prefetch size of 4,000 records.

  Misc
  - Updated Microsoft Graph to 5.61.0
  - Updated Azure.Identity to 1.13.1
  - Updated Microsoft.Identity.Client to 4.66.1

1.35:
  Misc
  - Updated Microsoft Graph to 5.58.0
  - Updated Microsoft.Identity.Client to 4.65.0

1.34:
  The dotnet tool version of PAC has been upgraded to .NET 8.0; the original MSI installed version of PAC remains on .NET Framework 4.8

  copilot
  - `merge-translations` fixed overwriting isCustomizable
  - `extract-template` fixed NotImplemented exception

  solution check
  - New --clearCache argument to clear the cache as part of the solution check process

  env
  - list-settings supports --json output format

  Misc
  - Updated Dataverse Service Client version to 1.1.27
  - Updated Microsoft.CrmSdk.SolutionPackagerLib version to 9.1.1.180
  - Updated Microsoft.Identity.Client to 4.63.0
  - Updated Microsoft.PowerPlatform.Dataverse.Client version to 1.1.32

1.33:
  Misc
  - Updated Azure.Identity to 1.12
  - Updated Microsoft Graph to 5.56.0
  - Updated Microsoft.Identity.Client to 4.61.3
  - Updated Dataverse ModelBuilder to 2.0.11
  - Updated Microsoft Power Fx 1.3.0-build.20240626-1003
  - Updated Microsoft.PowerPlatform.Formulas.Tools to 0.8.02735.117-preview (resolves https://github.com/microsoft/PowerApps-Tooling/issues/668)
  - Updated Microsoft.CrmSdk.SolutionPackagerLib version to 9.1.1.178

1.32:
  solution
  - `solution sync` now supports `--map` to skip items in the unpack process (https://github.com/microsoft/powerplatform-build-tools/discussions/832)
  - `solution clone` now supports `--map` to skip items in the unpack process (https://github.com/microsoft/powerplatform-build-tools/discussions/832)

  auth
  - New `auth who` verb which displays information about current authentication profile
  - (Preview) New `auth create` Federated login flows for Service Principals or User Assigned Managed Identities
    - These two new options permit authentication via Federated Credentials set in the Azure Portal
      instead of needing a Client Secret or Client Certificate on supported build agents.
    - GitHub Actions Federation via the `--githubFederated` switch
      Configuration instructions will be found on the next release of https://github.com/microsoft/powerplatform-actions/releases (ie, higher than the current v1.4.0)
    - Azure DevOps Task Federation via the `--azureDevOpsFederated` switch
      Configuration instructions will be found on the next release of https://github.com/microsoft/powerplatform-build-tools/releases (ie, higher than the current v2.0.63)
  - Fixed issue with Service Principal Certificate authentication expiring after 1 hour
  - Fixed issue with Managed Identities Auth Profile creation when the identity did not have optional BAP permissions.

  catalog
  - `catalog install` now supports `--target-env` to specify target environment (https://github.com/microsoft/powerplatform-build-tools/issues/872)

  Misc
  - Updated Microsoft.CrmSdk.SolutionPackagerLib version to 9.1.1.176
  - Updated Microsoft.PowerPlatform.Dataverse.Client version to 1.1.22

1.31:
  auth
  - Fixed `auth create` bug for SPNs on MacOS https://github.com/microsoft/powerplatform-build-tools/issues/716 reported by https://github.com/jjdd12
  - Fixed `auth create` with Managed Identity
  - Fixed `auth clear` bug with invalid or expired SPN profile

  solution
  - Fixed `solution pack/unpack` bug https://github.com/microsoft/powerplatform-build-tools/issues/695 reported by https://github.com/h-karthik12
  - Fixed `soltuion sync` bug https://github.com/microsoft/powerplatform-build-tools/discussions/772 reported by https://github.com/Zerajima

  copilot
  - Fixes export-template loading issue

  - Change default module type to 'es2020' to allow for better tree-shaking to reduce bundle size.
    - NOTE: If the previous behavior is required, add the line `"module": "commonjs"` to the `tsconfig.json` file under section `compilerOptions`.
  - Change default target type to 'es6'.
    - NOTE: If the previous behavior is required, add the line `"target": "es5"` to the `tsconfig.json` file under section `compilerOptions`.

  Fixed URL for the GCC/China/DoD PowerApps Checker endpoints
  Fixed Microsoft Graph endpoints for GCC &amp; GCC High

  Misc
  - Updated Microsoft.Identity.Client to 4.59.0
  - Updated Microsoft Graph version to 5.43.0
  - Updated Microsoft.CrmSdk.XrmTooling.CoreAssembly version to 9.1.1.57
  - Updated Microsoft Power Fx to 1.3
  - Updated SolutionPackager version to &gt;9.1.1.171

1.30:
  Affects all verbs:
  - The current Universal auth profile will now be selected before falling back on previous logic for the Dataverse and Admin auth profile kinds.
    This means that old profiles will never be used if there is an existing Universal profile.
    In the future, these old profiles will no longer be supported. Please create new profiles (which will be Universal) and set the --environment argument or 'pac org select' to set the active Dataverse environment for the profile.
  - All verbs that interact with Dataverse now support the `--environment` argument.
    This argument allows the user to explicitly override the active environment for the current profile.
    For most verbs this argument is optional, as it will fall back to the active environment for the current profile.
    Only when a verb will potentially corrupt or change security policies will these arguments be required to be specified. (e.g. pac admin copy, pac admin delete)

  auth
  - Deprecation of all but the Universal auth kinds. The `--kind` argument for `pac auth create` is now officially ignored. All new authentication profiles will use the Universal auth kind.
  - auth create argument `--url` is now deprecated, replaced with `--environment`. While `--url` supports only a url, the `--environment` argument supports organization id, environment id, and name searches. Other than the kinds of values allowed, these two argument behave the same.
  - Output of the `auth list` table has been reorganized.
    - Only Dataverse environment url's are displayed (for some profile kinds and for universal when the tenant doesn't have a default environment a service endpoint was being displayed)
    - Json result object also updated to use property `ActiveEnvironment` vs `Resource` and `FriendlyName`.
  - `org select`, `auth update --environment` will now verify the auth profile is able to authenticate with the environment before changing the active environment on the profile. This was causing some profiles to be corrupted.
  - `org select`, `auth update --environment` will only modify existing Universal and Dataverse environments.
  - Removed erroneous output "Connected to..." for verbs requiring authentication and supporting an `--environment` argument when the active profile had an active environment selected but the --environment argument on the command line is for a different environment.
  - Bug fix: Auth profile names should be unique. Existing profiles will get picked on the first in the list, but will not be possible to reuse a profile name.

  admin
  - set-runtime-state updates the environment administration mode
  - set-governance-config has 6 new arguments --maker-onboarding-url, --maker-onboarding-markdown, --suppress-validation-emails, --checker-rule-overrides, --cloud-flows-mode, --cloud-flows-limit

  copilot
  - Command renamed from `copilot` to `copilot model`. Users using e.g. `pac copilot list` need to change their commands to `pac copilot model list`.
  - Moved commands from `virtual-agent` to `copilot`.
  - Added alias `virtual-agent` to `copilot`. Users using e.g. `pac virtual-agent list` can continue to do so but are encouraged to changed their commands to `pac copilot list`.

  plugin
  - updated plugin template for init command

  Misc
  - Updated Dataverse Service Client version to 1.1.17
  - Updated SolutionPackager version to 9.1.1.164
  - Updated PDPackageGenerator version to 1.0.13
  - Updated Power Apps Checker version 1.0.0.17

1.29:
  auth
  - Security improvements to the storage mechanism for the Token Cache
    - Windows: no effective change; Token Cache is already stored via Windows Data Protection API for encryption at rest
    - macOS: Token Cache is now stored within Keychain.  This may lead to occasional OS prompts for PAC to access the Keychain
    - Linux:
      - For desktop environments with a Secret Service implementation (such as gnome-keyring or ksecretservice), the Token Cache is now stored there via libsecret.
      - If libsecret or a Secret Service implementation is not installed or not available (such as an SSH session, headless, or without x11), the Token Cache remains in a plaintext file with user-only (chomd 600) permissions.

  canvas download
  - Added new --extract-to-directory parameter to extract the contents of the downloaded msapp file to a directory

  power-fx
  - Added pfx alias for power-fx command
  - Added function list for Power Fx Repl

  pcf push supports target environment
  - Adds the --solution-unique-name argument (mutually exclusive with --publisher-prefix argument)
  - The temporary solution (and the temporary publisher) is now deleted after import is successful.
  - The publisher prefix from the target environment is used

  data import
  - returns nonzero exit code when import fails

  solution sync
  - Now supports long path names on Windows

  admin create
  - Added new --security-group-id parameter to specify the security group id for the environment as suggested by https://github.com/just-marc-stevenson
  https://github.com/microsoft/powerplatform-build-tools/discussions/535

  package deploy
  - New --solution argument which adds the ability to pass a solution to pac package deploy, using PD to deploy the solution
  This will allow for the deployment of solutions using the PD processor to support async, retry, timeout and other features
  that PD uses to deliver a solution.

  Misc
  - Updated Microsoft.PowerPlatform.PackageGeneratorLib to 1.0.10
  - Updated Microsoft.Identity.Client to 4.57.0
  - Updated Microsoft.Graph to 5.32.0

1.28:
  power-fx
  - new repl command for read-eval-print-loop of Power FX expressions
  - new run command to run Power FX expressions from file

  canvas
  - Added new list command to list all canvas apps in the environment
  - Added new download command to download msapp file for a canvas app

  data
  - Import command has new --connection-count parameter to specify the number of connections to use during import with 5 being the default

  admin
  - Create command has new --user parameter to specify the owner of the developer environment

  solution
  - Import command has new --stage-and-upgrade switch to perform a Solution Upgrade in a single command, instead of needing `pac solution import --import-as-holding` followed by a `pac solution upgrade`

  Misc
  - PAC CLI is outputting in Unicode (UTF16) by default
  - Improved environment discovery for service principal authentication
  - Improved service pricnipal access token refresh and exchange flows
  - Improved asyncronous polling
  - fixed https://github.com/microsoft/powerplatform-build-tools/issues/516 reported by https://github.com/joje1234
  - PAC CLI is now long path aware on Windows for file names longer than 260 characters
  - Updated Microsoft.Graph to 5.28.0

1.27:
  admin
  - Added new list-tenant-settings as requested by https://github.com/Laskewitz: https://github.com/microsoft/powerplatform-build-tools/discussions/460
  - Added new update-tenant-settings as requested by https://github.com/Laskewitz: https://github.com/microsoft/powerplatform-build-tools/discussions/460
  - Improved list command which now shows environment selected in current auth profile

  connection
  As requested by https://github.com/jboliveira and based on large number of votes on https://github.com/microsoft/powerplatform-build-tools/discussions/481
  - (Preview) Added create, update, list and delete verbs for Dataverse connections with Service Principal authentication

  org
  - Added new alias "env": "pac env list" is equivalent to "pac org list"

  paportal
  - Added new aliases "powerpages" and "pages"

  auth
  - create --managedIdentity flow can include regular users, specified by Username + Password Environment Variables

  Misc
  - Removed support for .NET 5.0
  - Updated Microsoft.Graph to 5.26.0
  - Updated Microsoft.PowerPlatform.Dataverse.Client to 1.1.14

1.26:
  pcf
  - Added new --incremental flag which only pushes changed files via entity update
  - project templates now include react and react-dom as devDependencies
  - Added pcfStartPath option to improve monorepo support

  admin
  - create-service-principal now has internal retry logic after Entra ID app creation
  - Most votes got idea from https://github.com/Laskewitz: https://github.com/microsoft/powerplatform-build-tools/discussions/406
    create-service-principal now has --name and --environment is optional
  - Added list-service-principal command to list all application service principals in the tenant which have access to Dataverse environments
  - Added support for managed environments with set-governance-config

  auth
  - Better detection of Azure Cloud based on environment URL
  - Operating system auth profile can now have default environment URL (org select)

  copilot
  - predict now accepts model by name in addition to model id
  - list shows which models are active or inactive

  test
  - execution of automated tests for Power Apps with Playwright

  catalog
  - Add Support for common Packager

  Misc
  - Updated Microsoft.PowerPlatform.Dataverse.Client to 1.1.12
  - Updated SolutionPackager to 9.1.1.156
  - Updated Microsoft.Graph to 5.21.0
  - Updated Dataverse ModelBuilder to 2.0.6
  - Updated Microsoft.PowerPlatform.Formulas.Tools to 0.6.4-preview
  - Added --log-to-console for use with Azure DevOps Build Tools

1.25:
  solution
  - "smarter" solution import (GitHub issue #200 by HansMeiser999). Added new --skip-lower-version flag to solution import
  - export path is optional

  org
  - New list-settings command displays list of current environment settings
  - New update-settings command updates environment settings

  pcf
  - Fixed pcf push when pac is installed as a dotnet tool
  - Updated init command defaults
  - Solution customization prefix is now optional during push
  - pcf-scripts is fixed when generated types were either deleted or contain errors

  admin
  - Updated assign-user to not error on duplicate entry
  - Added support for creating app user and assigning role to pac admin create-service-principal
  - Added support for managed environments with set-governance-config
  - Deprecated commands are now hidden from help but still available

  modelbuilder
  - Removed --generateactions Command and Replaced with --generatesdkmessages
            Change is backward compatible if using a settings file to generate. shortcut for generatesdkmessages remains -a for compatibility
  - Added --emitentityetc control for emitting ETC code in code base,  Defaulted is now to not emit ETC on write.
  - Added --emitvirtualattributes control for emitting Virtual Attributes as part of ModelBuilding. This allows access to "name" properties that are stored in the formatedvalues property bag.
          added at the request of git: https://github.com/microsoft/powerplatform-vscode/issues/509
  - Updated Suppress Code Generation attribute behavior to remove tool version from files.
  - Updated generation of field enums to a partial class to support the request on Git: https://github.com/microsoft/powerplatform-vscode/discussions/558
  - Fixed issue where Warning about not writhing Proxy attribute was not emitted to the console.  https://github.com/microsoft/powerplatform-vscode/issues/516
  - Fixed issue where SDK message builder would miss messages due to the volume of data being read from Dataverse. https://github.com/microsoft/powerplatform-vscode/issues/413

  copilot
  - New list command displays list of AI Builder models
  - New predict command allows to test AI Builder models

  Misc
  - Fixed 'React PCF creation not working' (GitHub issue #584 by Ionavoss)
  - Increased Dataverse Service Client Timeout to default of 30 minutes.
  - Updated Microsoft.Identity.Client to 4.54.1
  - Updated Microsoft.PowerPlatform.Formulas.Tools to 0.6.3-preview
  - Updated Microsoft.Xrm.Tooling.Dmt libraries to 4.0.0.139

1.24:
  admin
  - Added new command to allow for setting backup retention period of environments with managed environment enabled.
  - Added new --skip-audit-data flag to allow for skipping audit data during environment copy and restore.
  - Added new create-service-principal command to provide alternative for separate PowerShell script which creates Azure AD app.

  catalog
  - New catalog update command to update settings for a catalog

  solution
  - Fixed unpack command when solution contains canvas apps

  pipeline
  - Improved deployment wait flag and environment selection

  application
  - Added new "Application Id" column to list command
  - Added application argument to list command which will accept app id/app name

  copilot
  - (Preview) New: "copilot" for tools and utilities in copilot scenarios
  - (Preview) prepare-fetch: takes FetchXML file from AI LLM and prepares it for execution against Dataverse environment

  Misc
  - telemetry status now shows log file location
  - Updated Dataverse Service Client to 1.1.9
  - Updated Microsoft.PowerPlatform.Formulas.Tools to 0.6.2-preview
  - Nuget packages for CLI.Core* include all resource assemblies
  - Updated Microsoft.CrmSdk.XrmTooling.PackageDeployment.Core to 9.1.0.142

1.23:
  Added support for dotnet tool install on Windows, Linux, Mac: dotnet tool install --global Microsoft.PowerApps.CLI.Tool
  Added support for Web Account Manager - single sign-on, pac auth create is now optional on Windows

  connector create / update
  - Added Script support for pac connector create / update

  solution
  - clone: Added --localization switch to allow for localized solution clone operations.
  - sync: Added --localization switch to allow for localized solution sync operations.
  - init: Added new property (SolutionPackageEnableLocalization - true|false) to project file to enabled / disable localization during pack operations.
  - check: Added --saveResults switch to allow storing solution analysis results in the current Dataverse environment.

  paportal
  - Added bootstrap-migrate verb to pac paportal command that provides ability to migrate bootstrap v3 portal to bootstrap v5

  modelbuilder
  - New verbose flag [--loglevel] for modelbuilder

  data
  - Updated to latest CMT bits, including bug fixes

  package
  - Updated to latest package deployer bits, including new operation telemetry feature and bug fixes. Updated progress log reporting to reflect package progress notifications.

  Misc
  - Breaking change: Renamed Mooncake to China (--cloud China)
  - Updated fluent V9 platform library from 9.5.2 -&gt; 9.19.1.  This brings in the common PCF package that has the new fluent library and configuration json file.
  - SolutionPackager version is updated
  - GitLibrary updated in new version [ARM/Linux]

1.22.4:
  modelbuilder
  - Update to ModelBuilder lib to pick up bugfixes

  pcf push
  - support for interactive auth and console logging

  Catalog for Power Platform:
  - catalog list: List all published catalog items from the current Dataverse Organization.
  - catalog submit: Submit catalog approval request.
  - catalog install: Install a catalog item to the target environment.
  - catalog status: Get status of the catalog install/submit request.
  - catalog create-submission: Create catalog submission document. Note: This command will be removed in a future release."

  connector
  - create | update now accepts --solution-unique-name

  solution check
  - Support for additional GEOs: SouthAfrica, Norway, Singapore, Korea

  solution clone | sync: fixed issues in managed and unmanaged solutions

  admin list
  - supports for new argument --application-id

  paportal
  - Support for working with Power Pages websites utilizing the enhanced data model (v2)

1.21.13:
  - Fixed issues with versioning.
  - Connector noun support: Create/Update permit setting values via settings file

  PAPortal
  - Support for reading and writing optionsetvaluecollection.
  - Support for uploading datetime fields.
  - Download support for multi-language portals in v2 data model.
  - v1 webfiles having 'adx_migratedtofilecontent' attribute is no longer supported.
  - Support for custom name handling in v2 data model for entities.
  - Renamed 'annotations' to 'webfiles' in v2 data model download.
  - Added content field in 'powerpagesitelanguage', display name field to 'powerpagesitelanguage' entity.
  - Added additional fields to YML files.

  New Verb
  - (Preview) New Verb: "org fetch" to perform FetchXML query against Dataverse.

  Admin async operation improvements
  - `admin status` now displays the internal pac operation ID.
  - All admin verbs that support async operations now display the internal pac operation ID.
  - Deprecated `admin assign-user --async`.

1.21.8:
  - canvas pack|unpack: updated to Microsoft.PowerPlatform.Formulas.Tools to 0.5.8-preview.
  - modelbuilder updated to latest version 1.0.16
  - virtual-agent status: new verb to poll for completion of provisioning status of bots

1.21.4:
  - admin assign-group: new verb to complement assign-user
  - auth create: support for Azure Managed Identities
  - canvas pack|unpack: updated to Microsoft.PowerPlatform.Formulas.Tools to 0.5.7-preview.
  - pipeline: new noun to list and start in-product Pipelines
  - virtual-agent: listing of Power VA in environment

  - package: update to latest PD Core 9.1.0.118
  - update to latest Dataverse Service client lib 1.0.26

1.20.3:
  - modelbuilder build: generate C# classes from entities (integrates CrmSvcUtil functionality)

  - auth create: fix to handle client secrets starting with '-' (pp-build-tools #206)
  - solution check: fix incorrect checker endpoint urls for some sovereign clouds (pp-build-tools #211)
  - solution pack|unpack:
    - support PowerFX formulas in .yaml files for Entities
    - unpack will sort RootComponents, MissingDependencies, AppModules to reduce noisy diffs between exports/sync calls
  - solution sync: don't place PCF controls or plugin assemblies that are rebuilt from src via solution add-references

1.19.4:
  - QFE:
    - fix for pcf push: &lt;https://github.com/microsoft/powerplatform-vscode/issues/294&gt;
    - fix for solution sync: fails to package solution zip with 'Unable to find assembly registration configuration'

1.19.3:
  - canvas pack|unpack: updated to Microsoft.PowerPlatform.Formulas.Tools to 0.5.5-preview.
  - paportal: site visibility warning for upload/download verbs
  - solution import: reject with error if deployment settings has Dataverse EnvVars without value
  - tool cmt|pd|prt: install, launch and update WPF apps ConfigMigrationTool, PackageDeployer, PluginRegistrationTool

1.18.4:
  - admin assign-user: also support application user
  - application list|install: deprecate parameter `--environment-id` in favor of `--environment` which allows specifying url or id
  - auth create: support for appID/SPN authN via certificate (in addition to client secret)
  - canvas pack|unpack: updated to Microsoft.PowerPlatform.Formulas.Tools to 0.5.3-preview.
  - data import:
    - specify data to import as either directory or zip file with --data param
    - deprecating the now obsolete --dataDirectory param
    - NOTE: pac data import|export is a Windows-only feature for the time being
  - package deploy: pass in runtime settings for package parameters
  - plugin init: strong-name signing for plugin dll is opt-in now
  - PREVIEW: new noun connector with verbs for interacting with Custom Connectors in Power Apps
  - Updated to latest SolutionPackager (9.1.0.128)

1.17.6:
  - macOS/linux: pac CLI now runs on and requires .NET6; get SDK installer from: https://dotnet.microsoft.com/en-us/download
    NOTE: when running pac CLI on Apple Silicon ARM (M1/M2) macOS, this version still requires to also have the intel/x64 .NET6 SDK to be installed!!
  - shipping with GA-ed Dataverse Service client (1.0.9)
  - admin: new verbs:
    - list-app-templates: enumerate available D365 application templates
    - assign-user: Assign a user and role to a target environment
  - auth:
    - create verb, new opt. parameter: select a default environment by url, domain name or environmentId; change later with `pac org select`
    - update verb: update name or default env url/id for existing auth profile
  - canvas:
    - create: new verb to generate Power Apps from custom connector
    - updated to Microsoft.PowerPlatform.Formulas.Tools to 0.5.2-preview.
  - data: new module to import/export configuration data, similar to CMT
  - org:
    - select: change pre-selected environment to use for e.g. solution export etc.
    - list now supports filtering
  - package:
    - add-external-package: Adds support for external packages to app packages, including FnO packages.
  - plugin:
    - push: directly update an already registered plugin dll/package in the selected environment
    - init:
      - updated plugin code template with added ILogger, ServiceProvider, OrgSvcFactory accessors
      - added ability to skip plug-in assembly signing which gives plug-in assembly strong name via new --skip-signing switch
  - solution:
    - add-solution-component: adds a solution component to the unmanaged solution in the connected Dataverse environment
    - clone:
      - also packs and unpacks any Canvas apps in solution.zip (new param --processCanvasApps)
      - allow selecting managed/unmanaged solution
    - sync, currently in preview:
      -updates a previously cloned solution in the local filesystem with latest changes made in Maker studio
      - also packs and unpacks any Canvas apps in solution.zip (new param --processCanvasApps)
      - allow selecting managed/unmanaged solution
    - check: extended default timeout to 1hr to check even larger/complex solution

1.16.6:
  - auth create now supports "Single Sign On":
    - '--kind' parameter is deprecated but still valid to use with its DATAVERSE and ADMIN kind values; defaults now to UNIVERSAL
    - '--url' is now optional, will select default environment in tenant
    - the single sign on authN can be used with all pac CLI nouns
  - canvas: updated Microsoft.PowerPlatform.Formulas.Tools to 0.5.0-preview.
  - admin:
    - added China sovereign cloud admin endpoints
    - fixed --language argument to accetp language ids and suggest valid ids
  - package deploy: fixed error when packages contain .cab files
  - solution check: --path supports now wildcards and globbing
  - solution list: show if solutions are managed or not

1.15.3:
  - admin: Added ability to backup, restore and list Microsoft Teams Power Apps environments.
  - admin backup: --notes parameter has been deprecated in both pac CLI and service endpoint
  - canvas: updated Microsoft.PowerPlatform.Formulas.Tools to 0.4.5-preview.
    see also &lt;https://github.com/microsoft/PowerApps-Language-Tooling/releases/tag/0.4.5-preview&gt;
  - package:
    added support for creating and building additional package types, Dataverse For Teams, UNO
    - init: now defaults to creating package projects as new sdk-style projects.
    - add-solution: add prebuilt solution.zip to package.
    - add-reference: support the new sdk-style project type.
  - plugin: support building Dataverse plugins with dependent assemblies into nuget package
  - solution:
    - export|clone: parameter --targetVersion deprecated (not supported by Dataverse 9.x)
    - pack|unpack verbs: also packs and unpacks any Canvas apps in solution.zip (new param --processCanvasApps)
    - publish: Added ability to publish customizations asynchronously
    - upgrade: check that an upgradeable solution exists in target environment
  - Updated to latest SolutionPackager (9.1.0.110) and Dataverse Service Client (0.6.6) libraries

1.14.4:
  - admin create: Added ability to create Microsoft Teams environments
  - admin reset: fix language name parsing for --language
  - canvas: updated Microsoft.PowerPlatform.Formulas.Tools to 0.4.2-preview.
  - pcf init: support for React(virtual) and Fluent UI code components using platform libraries.
  - pcf version | solution version: Fix "gittags" and "filetracking "version update strategies
  - org list: fixed list of environments for authentication profiles in sovereign clouds
  - emit path to pac CLI's diagnostic log when encountering non-recoverable errors

1.13.6:
  - admin copy: fix regression when specifying --source-url was rejected with error
  - new 'pac application' noun: list and install packages/application available for the PP tenant to the target environment
  - canvas: updated Microsoft.PowerPlatform.Formulas.Tools to 0.4.0-preview.
    - Added support for first-party PCF Control conversions.
    - Controls and components with conflicting names will no longer overwrite the editor state.
    - Empty test suites will no longer cause issues when roundtripping.
    see also &lt;https://github.com/microsoft/PowerApps-Language-Tooling/releases/tag/0.4.0-preview&gt;
  - paportal download: fix 'missing root pages' error for non-English PowerPages
  - solution pack|unpack: latest SoPa 9.1.0.107
    - strip XML comments from localizable elements
    - fix AssemblyQualifiedName mapping for plugins

1.12.2:
- Device Code Authentication:
  `pac auth create` now supports Device Code Authentication via the `--deviceCode` switch
- pcf init framework argument is now case insensitive
- "none" is no longer available as copy type for copy environment
- Fixed issue where pac pcf init fails with an unrecognized error when using --run-npm-install
- Updated pcf dependencies
- pac auth clear now deletes local user token cache

1.11.8:
- Sovereign cloud support authentication support:
  pac admin and pac auth | org | paportal | solution noun/verbs can now interact with sovereign cloud environments
- Interactive OAuth logins now use single appID for all endpoints
- Update to latest SolutionPackager library:
    - localization support for solution aware entities
    - fix handling of CanvasApp where app name and paths to composite files (.msapp, image) differ; file name reference in meta xml is now source of truth
    - fix EntityRelationshipRole/AssociationRoleOrdinal search bug
- pac package init: improved/fixed package template project
- paportal:
    - improve error handling for deleted and missing key
    - adding option to specify locale file format json or yaml
- solution:
    - fix version verb to correctly increment version tuple in solution.xml (preserving version tupleness)
    - add additional parameters (--solutionUri, --excludedFiles) to check verb

1.10.4:
- pac auth create: fixed interactive login for --kind admin on .NET Core 5 (linux, macOS)
- pac canvas pack: updated to latest library with fix for issue https://github.com/microsoft/PowerApps-Language-Tooling/issues/319
- pac org list: enumerate reachable Dataverse environments, using global discovery service
- pac paportal: added missing attributes adx_attachfileacceptextensions, adx_attachfilesaveoption
- pac solution add-license: fixed reported unhandled exception errors
- added: pac solution delete
- added: pac solution online-version to update version in connected Dataverse environment
- pac solution unpack
  - fixed issue with resource localization incorrectly using Lcid ID's when not requested
  - fixed issue with --allowDelete causing pac to hang.
  - fixed issue with --useUnmanagedFileForMissingManaged that caused the setting to be ignored.
  - fixed issue with --useLcid that caused the setting to be ignored.
- pac solution pack   - plugin references in solution will be remapped to full strong name (type/version/pubKeyToken) of assembly;
      --disablePluginRemap to disable plugin type name remapping</releaseNotes>
    <copyright>© Microsoft Corporation. All rights reserved.</copyright>
    <language>en-US</language>
    <tags>Dynamics CRM PowerApps PowerPlatform</tags>
  </metadata>
</package>